searchData={"content_type":"text/plain","items":[{"doc":"Compile-time expansion utility This module serves as an example of parse_trans-based transforms, but might also be a useful utility in its own right. The transform searches for calls to the pseudo-function ct_expand:term(Expr) , and then replaces the call site with the result of evaluating Expr at compile-time. For example, the line ct_expand:term(lists:sort([3,5,2,1,4])) would be expanded at compile-time to [1,2,3,4,5] . ct_expand has now been extended to also evaluate calls to local functions. See examples/ct_expand_test.erl for some examples. A debugging facility exists: passing the option {ct_expand_trace, Flags} as an option, or adding a compiler attribute -ct_expand_trace(Flags) will enable a form of call trace. Flags can be [] (no trace) or [F] , where F is c (call trace), r (return trace), or x (exception trace)'.","ref":"ct_expand.html","title":"ct_expand","type":"module"},{"doc":null,"ref":"ct_expand.html#extract_fun/3","title":"ct_expand.extract_fun/3","type":"function"},{"doc":null,"ref":"ct_expand.html#lfun_rewrite/2","title":"ct_expand.lfun_rewrite/2","type":"function"},{"doc":null,"ref":"ct_expand.html#parse_transform/2","title":"ct_expand.parse_transform/2","type":"function"},{"doc":null,"ref":"ct_expand.html#t:abstract_expr/0","title":"ct_expand.abstract_expr/0","type":"type"},{"doc":null,"ref":"ct_expand.html#t:form/0","title":"ct_expand.form/0","type":"type"},{"doc":null,"ref":"ct_expand.html#t:forms/0","title":"ct_expand.forms/0","type":"type"},{"doc":null,"ref":"ct_expand.html#t:options/0","title":"ct_expand.options/0","type":"type"},{"doc":"Parse transform for generating record access functions. This parse transform can be used to reduce compile-time dependencies in large systems. In the old days, before records, Erlang programmers often wrote access functions for tuple data. This was tedious and error-prone. The record syntax made this easier, but since records were implemented fully in the pre-processor, a nasty compile-time dependency was introduced. This module automates the generation of access functions for records. While this method cannot fully replace the utility of pattern matching, it does allow a fair bit of functionality on records without the need for compile-time dependencies. Whenever record definitions need to be exported from a module, inserting a compiler attribute, export_records([RecName|...]) causes this transform to lay out access functions for the exported records: As an example, consider the following module: -module(test_exprecs). -record(r,{a = 0 :: integer(),b = 0 :: integer(),c = 0 :: integer()}). -record(s,{a}). -record(t,{}). -export_records([r,s,t]). -export_type(['#prop-r'/0, '#attr-r'/0, '#prop-s'/0, '#attr-s'/0, '#prop-t'/0, '#attr-t'/0]). -type '#prop-s'() :: {a, any()}. -type '#attr-s'() :: a. -type '#prop-r'() :: {a, any()} | {b, any()} | {c, any()}. -type '#attr-r'() :: a | b | c. -type '#prop-t'() :: any(). -type '#attr-t'() :: any(). -spec '#exported_records-'() -&gt; [r | s | t]. -spec '#new-'(r) -&gt; #r{}; (s) -&gt; #s{}; (t) -&gt; #t{}. -spec '#info-'(r) -&gt; ['#attr-r'()]; (s) -&gt; ['#attr-s'()]; (t) -&gt; ['#attr-t'()]. -spec '#info-'(r, size) -&gt; 4; (r, fields) -&gt; ['#attr-r'()]; (s, size) -&gt; 2; (s, fields) -&gt; ['#attr-s'()]; (t, size) -&gt; 1; (t, fields) -&gt; ['#attr-t'()]. -spec '#pos-'(r, a) -&gt; 1; (r, b) -&gt; 2; (r, c) -&gt; 3; (s, a) -&gt; 1. -spec '#is_record-'(any()) -&gt; boolean(). -spec '#is_record-'(any(), any()) -&gt; boolean(). -spec '#get-'(a, #s{}) -&gt; any(); (a, #r{}) -&gt; any(); (b, #r{}) -&gt; any(); (c, #r{}) -&gt; any(); (['#attr-t'()], #t{}) -&gt; []; (['#attr-s'()], #s{}) -&gt; [any()]; (['#attr-r'()], #r{}) -&gt; [any()]. -spec '#set-'(['#prop-r'()], #r{}) -&gt; #r{}; (['#prop-s'()], #s{}) -&gt; #s{}; (['#prop-t'()], #t{}) -&gt; #t{}. -spec '#fromlist-'(['#prop-r'()], #r{}) -&gt; #r{}; (['#prop-s'()], #s{}) -&gt; #s{}; (['#prop-t'()], #t{}) -&gt; #t{}. -spec '#frommap-'(#{a =&gt; any(), b =&gt; any(), c =&gt; any()}, #r{}) -&gt; #r{}; (#{a =&gt; any()}, #s{}) -&gt; #s{}; (#{}, #t{}) -&gt; #t{}. -spec '#lens-'('#attr-r'(), r) -&gt; {fun((#r{}) -&gt; any()), fun((any(), #r{}) -&gt; #r{})}; ('#attr-s'(), s) -&gt; {fun((#s{}) -&gt; any()), fun((any(), #s{}) -&gt; #s{})}; ('#attr-t'(), t) -&gt; {fun((#t{}) -&gt; any()), fun((any(), #t{}) -&gt; #t{})}. -spec '#new-r'() -&gt; #r{}. -spec '#new-r'(['#prop-r'()]) -&gt; #r{}. -spec '#get-r'(a, #r{}) -&gt; any(); (b, #r{}) -&gt; any(); (c, #r{}) -&gt; any(); (['#attr-r'()], #r{}) -&gt; [any()]. -spec '#set-r'(['#prop-r'()], #r{}) -&gt; #r{}. -spec '#fromlist-r'(['#prop-r'()]) -&gt; #r{}. -spec '#fromlist-r'(['#prop-r'()], #r{}) -&gt; #r{}. -spec '#frommap-r'(#{a =&gt; any(), b =&gt; any(), c =&gt; any()}) -&gt; #r{}. -spec '#frommap-r'(#{a =&gt; any(), b =&gt; any(), c =&gt; any()}, #r{}) -&gt; #r{}. -spec '#pos-r'('#attr-r'() | atom()) -&gt; integer(). -spec '#info-r'(fields) -&gt; [a | b | c]; (size) -&gt; 4. -spec '#lens-r'('#attr-r'()) -&gt; {fun((#r{}) -&gt; any()), fun((any(), #r{}) -&gt; #r{})}. -spec '#new-s'() -&gt; #s{}. -spec '#new-s'(['#prop-s'()]) -&gt; #s{}. -spec '#get-s'(a, #s{}) -&gt; any(); (['#attr-s'()], #s{}) -&gt; [any()]. -spec '#set-s'(['#prop-s'()], #s{}) -&gt; #s{}. -spec '#fromlist-s'(['#prop-s'()]) -&gt; #s{}. -spec '#fromlist-s'(['#prop-s'()], #s{}) -&gt; #s{}. -spec '#frommap-s'(#{a =&gt; any()}) -&gt; #s{}. -spec '#frommap-s'(#{a =&gt; any()}, #s{}) -&gt; #s{}. -spec '#pos-s'('#attr-s'() | atom()) -&gt; integer(). -spec '#info-s'(fields) -&gt; [a]; (size) -&gt; 2. -spec '#lens-s'('#attr-s'()) -&gt; {fun((#s{}) -&gt; any()), fun((any(), #s{}) -&gt; #s{})}. -spec '#new-t'() -&gt; #t{}. -spec '#new-t'(['#prop-t'()]) -&gt; #t{}. -spec '#get-t'(['#attr-t'()], #t{}) -&gt; [any()]. -spec '#set-t'(['#prop-t'()], #t{}) -&gt; #t{}. -spec '#fromlist-t'(['#prop-t'()]) -&gt; #t{}. -spec '#fromlist-t'(['#prop-t'()], #t{}) -&gt; #t{}. -spec '#frommap-t'(#{}) -&gt; #t{}. -spec '#frommap-t'(#{}, #t{}) -&gt; #t{}. -spec '#pos-t'('#attr-t'() | atom()) -&gt; integer(). -spec '#info-t'(fields) -&gt; []; (size) -&gt; 1. -spec '#lens-t'('#attr-t'()) -&gt; {fun((#t{}) -&gt; any()), fun((any(), #t{}) -&gt; #t{})}. -file(&quot;c:/git/etp/_checkouts/parse_trans/examples/test_exprecs.erl&quot;, 1). '#exported_records-'() -&gt; [r,s,t]. '#new-'(r) -&gt; '#new-r'(); '#new-'(s) -&gt; '#new-s'(); '#new-'(t) -&gt; '#new-t'(). '#info-'(RecName) -&gt; '#info-'(RecName, fields). '#info-'(r, Info) -&gt; '#info-r'(Info); '#info-'(s, Info) -&gt; '#info-s'(Info); '#info-'(t, Info) -&gt; '#info-t'(Info). '#pos-'(r, Attr) -&gt; '#pos-r'(Attr); '#pos-'(s, Attr) -&gt; '#pos-s'(Attr); '#pos-'(t, Attr) -&gt; '#pos-t'(Attr). '#is_record-'(X) -&gt; if is_record(X, r, 4) -&gt; true; is_record(X, s, 2) -&gt; true; is_record(X, t, 1) -&gt; true; true -&gt; false end. '#is_record-'(t, Rec) when tuple_size(Rec) == 1, element(1, Rec) == t -&gt; true; '#is_record-'(s, Rec) when tuple_size(Rec) == 2, element(1, Rec) == s -&gt; true; '#is_record-'(r, Rec) when tuple_size(Rec) == 4, element(1, Rec) == r -&gt; true; '#is_record-'(_, _) -&gt; false. '#get-'(Attrs, {r,_,_,_} = Rec) when true -&gt; '#get-r'(Attrs, Rec); '#get-'(Attrs, {s,_} = Rec) when true -&gt; '#get-s'(Attrs, Rec); '#get-'(Attrs, {t} = Rec) when true -&gt; '#get-t'(Attrs, Rec). '#set-'(Vals, {r,_,_,_} = Rec) when true -&gt; '#set-r'(Vals, Rec); '#set-'(Vals, {s,_} = Rec) when true -&gt; '#set-s'(Vals, Rec); '#set-'(Vals, {t} = Rec) when true -&gt; '#set-t'(Vals, Rec). '#fromlist-'(Vals, {r,_,_,_} = Rec) when true -&gt; '#fromlist-r'(Vals, Rec); '#fromlist-'(Vals, {s,_} = Rec) when true -&gt; '#fromlist-s'(Vals, Rec); '#fromlist-'(Vals, {t} = Rec) when true -&gt; '#fromlist-t'(Vals, Rec). '#frommap-'(Vals, {r,_,_,_} = Rec) when true -&gt; '#frommap-r'(Vals, Rec); '#frommap-'(Vals, {s,_} = Rec) when true -&gt; '#frommap-s'(Vals, Rec); '#frommap-'(Vals, {t} = Rec) when true -&gt; '#frommap-t'(Vals, Rec). '#lens-'(Attr, r) -&gt; '#lens-r'(Attr); '#lens-'(Attr, s) -&gt; '#lens-s'(Attr); '#lens-'(Attr, t) -&gt; '#lens-t'(Attr). '#new-r'() -&gt; {r,0,0,0}. '#new-r'(Vals) -&gt; '#set-r'(Vals, {r,0,0,0}). '#get-r'(Attrs, R) when is_list(Attrs) -&gt; [ '#get-r'(A, R) || A &lt;- Attrs ]; '#get-r'(a, R) -&gt; case R of {r,rec0,_,_} -&gt; rec0; _ -&gt; error({badrecord,r}) end; '#get-r'(b, R) -&gt; case R of {r,_,rec1,_} -&gt; rec1; _ -&gt; error({badrecord,r}) end; '#get-r'(c, R) -&gt; case R of {r,_,_,rec2} -&gt; rec2; _ -&gt; error({badrecord,r}) end; '#get-r'(Attr, R) -&gt; error(bad_record_op, ['#get-r',Attr,R]). '#set-r'(Vals, Rec) -&gt; F = % fun-info: {0,0,'-#set-r/2-fun-0-'} fun([], R, _F1) -&gt; R; ([{a,V}|T], R, F1) when is_list(T) -&gt; F1(T, begin rec3 = R, case rec3 of {r,_,_,_} -&gt; setelement(2, rec3, V); _ -&gt; error({badrecord,r}) end end, F1); ([{b,V}|T], R, F1) when is_list(T) -&gt; F1(T, begin rec4 = R, case rec4 of {r,_,_,_} -&gt; setelement(3, rec4, V); _ -&gt; error({badrecord,r}) end end, F1); ([{c,V}|T], R, F1) when is_list(T) -&gt; F1(T, begin rec5 = R, case rec5 of {r,_,_,_} -&gt; setelement(4, rec5, V); _ -&gt; error({badrecord,r}) end end, F1); (Vs, R, _) -&gt; error(bad_record_op, ['#set-r',Vs,R]) end, F(Vals, Rec, F). '#fromlist-r'(Vals) when is_list(Vals) -&gt; '#fromlist-r'(Vals, '#new-r'()). '#fromlist-r'(Vals, Rec) -&gt; AttrNames = [{a,2},{b,3},{c,4}], F = % fun-info: {0,0,'-#fromlist-r/2-fun-0-'} fun([], R, _F1) -&gt; R; ([{H,Pos}|T], R, F1) when is_list(T) -&gt; case lists:keyfind(H, 1, Vals) of false -&gt; F1(T, R, F1); {_,Val} -&gt; F1(T, setelement(Pos, R, Val), F1) end end, F(AttrNames, Rec, F). '#frommap-r'(Vals) when is_map(Vals) -&gt; '#frommap-r'(Vals, '#new-r'()). '#frommap-r'(Vals, Rec) -&gt; List = maps:to_list(Vals), '#fromlist-r'(List, Rec). '#pos-r'(a) -&gt; 2; '#pos-r'(b) -&gt; 3; '#pos-r'(c) -&gt; 4; '#pos-r'(A) when is_atom(A) -&gt; 0. '#info-r'(fields) -&gt; [a,b,c]; '#info-r'(size) -&gt; 4. '#lens-r'(a) -&gt; {% fun-info: {0,0,'-#lens-r/1-fun-0-'} fun(R) -&gt; '#get-r'(a, R) end, % fun-info: {0,0,'-#lens-r/1-fun-1-'} fun(X, R) -&gt; '#set-r'([{a,X}], R) end}; '#lens-r'(b) -&gt; {% fun-info: {0,0,'-#lens-r/1-fun-2-'} fun(R) -&gt; '#get-r'(b, R) end, % fun-info: {0,0,'-#lens-r/1-fun-3-'} fun(X, R) -&gt; '#set-r'([{b,X}], R) end}; '#lens-r'(c) -&gt; {% fun-info: {0,0,'-#lens-r/1-fun-4-'} fun(R) -&gt; '#get-r'(c, R) end, % fun-info: {0,0,'-#lens-r/1-fun-5-'} fun(X, R) -&gt; '#set-r'([{c,X}], R) end}; '#lens-r'(Attr) -&gt; error(bad_record_op, ['#lens-r',Attr]). '#new-s'() -&gt; {s,undefined}. '#new-s'(Vals) -&gt; '#set-s'(Vals, {s,undefined}). '#get-s'(Attrs, R) when is_list(Attrs) -&gt; [ '#get-s'(A, R) || A &lt;- Attrs ]; '#get-s'(a, R) -&gt; case R of {s,rec6} -&gt; rec6; _ -&gt; error({badrecord,s}) end; '#get-s'(Attr, R) -&gt; error(bad_record_op, ['#get-s',Attr,R]). '#set-s'(Vals, Rec) -&gt; F = % fun-info: {0,0,'-#set-s/2-fun-0-'} fun([], R, _F1) -&gt; R; ([{a,V}|T], R, F1) when is_list(T) -&gt; F1(T, begin rec7 = R, case rec7 of {s,rec8} -&gt; {s,V}; _ -&gt; error({badrecord,s}) end end, F1); (Vs, R, _) -&gt; error(bad_record_op, ['#set-s',Vs,R]) end, F(Vals, Rec, F). '#fromlist-s'(Vals) when is_list(Vals) -&gt; '#fromlist-s'(Vals, '#new-s'()). '#fromlist-s'(Vals, Rec) -&gt; AttrNames = [{a,2}], F = % fun-info: {0,0,'-#fromlist-s/2-fun-0-'} fun([], R, _F1) -&gt; R; ([{H,Pos}|T], R, F1) when is_list(T) -&gt; case lists:keyfind(H, 1, Vals) of false -&gt; F1(T, R, F1); {_,Val} -&gt; F1(T, setelement(Pos, R, Val), F1) end end, F(AttrNames, Rec, F). '#frommap-s'(Vals) when is_map(Vals) -&gt; '#frommap-s'(Vals, '#new-s'()). '#frommap-s'(Vals, Rec) -&gt; List = maps:to_list(Vals), '#fromlist-s'(List, Rec). '#pos-s'(a) -&gt; 2; '#pos-s'(A) when is_atom(A) -&gt; 0. '#info-s'(fields) -&gt; [a]; '#info-s'(size) -&gt; 2. '#lens-s'(a) -&gt; {% fun-info: {0,0,'-#lens-s/1-fun-0-'} fun(R) -&gt; '#get-s'(a, R) end, % fun-info: {0,0,'-#lens-s/1-fun-1-'} fun(X, R) -&gt; '#set-s'([{a,X}], R) end}; '#lens-s'(Attr) -&gt; error(bad_record_op, ['#lens-s',Attr]). '#new-t'() -&gt; {t}. '#new-t'(Vals) -&gt; '#set-t'(Vals, {t}). '#get-t'(Attrs, R) when is_list(Attrs) -&gt; [ '#get-t'(A, R) || A &lt;- Attrs ]; '#get-t'(Attr, R) -&gt; error(bad_record_op, ['#get-t',Attr,R]). '#set-t'(Vals, Rec) -&gt; F = % fun-info: {0,0,'-#set-t/2-fun-0-'} fun([], R, _F1) -&gt; R; (Vs, R, _) -&gt; error(bad_record_op, ['#set-t',Vs,R]) end, F(Vals, Rec, F). '#fromlist-t'(Vals) when is_list(Vals) -&gt; '#fromlist-t'(Vals, '#new-t'()). '#fromlist-t'(Vals, Rec) -&gt; AttrNames = [], F = % fun-info: {0,0,'-#fromlist-t/2-fun-0-'} fun([], R, _F1) -&gt; R; ([{H,Pos}|T], R, F1) when is_list(T) -&gt; case lists:keyfind(H, 1, Vals) of false -&gt; F1(T, R, F1); {_,Val} -&gt; F1(T, setelement(Pos, R, Val), F1) end end, F(AttrNames, Rec, F). '#frommap-t'(Vals) when is_map(Vals) -&gt; '#frommap-t'(Vals, '#new-t'()). '#frommap-t'(Vals, Rec) -&gt; List = maps:to_list(Vals), '#fromlist-t'(List, Rec). '#pos-t'(A) when is_atom(A) -&gt; 0. '#info-t'(fields) -&gt; []; '#info-t'(size) -&gt; 1. '#lens-t'(Attr) -&gt; error(bad_record_op, ['#lens-t',Attr]). f() -&gt; foo. It is possible to modify the naming rules of exprecs, through the use of the following attributes (example reflecting the current rules): - exprecs_prefix ( [ &quot;#&quot; , operation , &quot;-&quot; ] ) . - exprecs_fname ( [ prefix , record ] ) . - exprecs_vfname ( [ fname , &quot;__&quot; , version ] ) . The lists must contain strings or any of the following control atoms: in exprecs_prefix : operation in exprecs_fname : operation , record , prefix in exprecs_vfname : operation , record , prefix , fname , version Exprecs will substitute the control atoms with the string values of the corresponding items. The result will then be flattened and converted to an atom (a valid function or type name). operation is one of: new Creates a new record get Retrieves given attribute values from a record set Sets given attribute values in a record fromlist Creates a record from a key-value list info Equivalent to record_info/2 pos Returns the position of a given attribute is_record Tests if a value is a specific record convert Converts an old record to the current version prop Used only in type specs attr Used only in type specs lens Returns a 'lens' (an accessor pair) as described in http://github.com/jlouis/erl-lenses","ref":"exprecs.html","title":"exprecs","type":"module"},{"doc":null,"ref":"exprecs.html#context/2","title":"exprecs.context/2","type":"function"},{"doc":null,"ref":"exprecs.html#format_error/1","title":"exprecs.format_error/1","type":"function"},{"doc":null,"ref":"exprecs.html#parse_transform/2","title":"exprecs.parse_transform/2","type":"function"},{"doc":null,"ref":"exprecs.html#t:form/0","title":"exprecs.form/0","type":"type"},{"doc":null,"ref":"exprecs.html#t:forms/0","title":"exprecs.forms/0","type":"type"},{"doc":null,"ref":"exprecs.html#t:options/0","title":"exprecs.options/0","type":"type"},{"doc":"Generic parse transform library for Erlang. ...","ref":"parse_trans.html","title":"parse_trans","type":"module"},{"doc":"Accessor function for the Context record.","ref":"parse_trans.html#context/2","title":"parse_trans.context/2","type":"function"},{"doc":null,"ref":"parse_trans.html#depth_first/4","title":"parse_trans.depth_first/4","type":"function"},{"doc":null,"ref":"parse_trans.html#do_depth_first/4","title":"parse_trans.do_depth_first/4","type":"function"},{"doc":null,"ref":"parse_trans.html#do_insert_forms/4","title":"parse_trans.do_insert_forms/4","type":"function"},{"doc":null,"ref":"parse_trans.html#do_inspect/4","title":"parse_trans.do_inspect/4","type":"function"},{"doc":null,"ref":"parse_trans.html#do_transform/4","title":"parse_trans.do_transform/4","type":"function"},{"doc":"Used to report errors detected during the parse transform.","ref":"parse_trans.html#error/3","title":"parse_trans.error/3","type":"function"},{"doc":null,"ref":"parse_trans.html#export_function/3","title":"parse_trans.export_function/3","type":"function"},{"doc":null,"ref":"parse_trans.html#format_error/1","title":"parse_trans.format_error/1","type":"function"},{"doc":"Equivalent to format_exception(Class, Reason, 4) .","ref":"parse_trans.html#format_exception/2","title":"parse_trans.format_exception/2","type":"function"},{"doc":"Produces a few lines of user-friendly formatting of exception info This function is very similar to the exception pretty-printing in the shell, but returns a string that can be used as error info e.g. by error forms handled by return/2 . By default, the first 4 lines of the pretty-printed exception info are returned, but this can be controlled with the Lines parameter. Note that a stacktrace is generated inside this function.","ref":"parse_trans.html#format_exception/3","title":"parse_trans.format_exception/3","type":"function"},{"doc":"Checks whether the given function is defined in Forms.","ref":"parse_trans.html#function_exists/3","title":"parse_trans.function_exists/3","type":"function"},{"doc":"Returns the value of the first occurrence of attribute A.","ref":"parse_trans.html#get_attribute/2","title":"parse_trans.get_attribute/2","type":"function"},{"doc":null,"ref":"parse_trans.html#get_attribute/3","title":"parse_trans.get_attribute/3","type":"function"},{"doc":"Returns the name of the file being compiled.","ref":"parse_trans.html#get_file/1","title":"parse_trans.get_file/1","type":"function"},{"doc":"Returns the name of the module being compiled.","ref":"parse_trans.html#get_module/1","title":"parse_trans.get_module/1","type":"function"},{"doc":"Fetches a Syntax Tree representing the code before pre-processing, that is, including record and macro definitions. Note that macro definitions must be syntactically complete forms (this function uses epp_dodger).","ref":"parse_trans.html#get_orig_syntax_tree/1","title":"parse_trans.get_orig_syntax_tree/1","type":"function"},{"doc":"Tries to retrieve the line number from an erl_syntax form. Returns a (very high) dummy number if not successful.","ref":"parse_trans.html#get_pos/1","title":"parse_trans.get_pos/1","type":"function"},{"doc":"Initializes a context record. When traversing through the form list, the context is updated to reflect the current function and arity. Static elements in the context are the file name, the module name and the options passed to the transform function.","ref":"parse_trans.html#initial_context/2","title":"parse_trans.initial_context/2","type":"function"},{"doc":"Equivalent to do_inspect(Fun,Acc,Forms,initial_context(Forms,Options)).","ref":"parse_trans.html#inspect/4","title":"parse_trans.inspect/4","type":"function"},{"doc":null,"ref":"parse_trans.html#optionally_pretty_print/3","title":"parse_trans.optionally_pretty_print/3","type":"function"},{"doc":"Performs a transform of Forms using the fun Fun(Form) . Form is always an Erlang abstract form, i.e. it is not converted to syntax_tools representation. The intention of this transform is for the fun to have a catch-all clause returning continue . This will ensure that it stays robust against additions to the language. Fun(Form) must return either of the following: * NewForm - any valid form * continue - dig into the sub-expressions of the form * {done, NewForm} - Replace Form with NewForm ; return all following forms unchanged * {error, Reason} - Abort transformation with an error message. Example - This transform fun would convert all instances of P ! Msg to gproc:send(P, Msg) : parse_transform ( Forms , _ Options ) -&gt; parse_trans : plain_transform ( fun do_transform / 1 , Forms ) . do_transform ( { &#39;op&#39; , L , &#39;!&#39; , Lhs , Rhs } ) -&gt; [ NewLhs ] = parse_trans : plain_transform ( fun do_transform / 1 , [ Lhs ] ) , [ NewRhs ] = parse_trans : plain_transform ( fun do_transform / 1 , [ Rhs ] ) , { call , L , { remote , L , { atom , L , gproc } , { atom , L , send } } , [ NewLhs , NewRhs ] } ; do_transform ( _ ) -&gt; continue .","ref":"parse_trans.html#plain_transform/2","title":"parse_trans.plain_transform/2","type":"function"},{"doc":"Reads debug_info from the beam file Beam and returns a string containing the pretty-printed corresponding erlang source code.","ref":"parse_trans.html#pp_beam/1","title":"parse_trans.pp_beam/1","type":"function"},{"doc":"Reads debug_info from the beam file Beam and pretty-prints it as Erlang source code, storing it in the file Out.","ref":"parse_trans.html#pp_beam/2","title":"parse_trans.pp_beam/2","type":"function"},{"doc":"Pretty-prints the erlang source code corresponding to Forms into Out","ref":"parse_trans.html#pp_src/2","title":"parse_trans.pp_src/2","type":"function"},{"doc":null,"ref":"parse_trans.html#replace_function/4","title":"parse_trans.replace_function/4","type":"function"},{"doc":null,"ref":"parse_trans.html#replace_function/5","title":"parse_trans.replace_function/5","type":"function"},{"doc":"Checks the transformed result for errors and warnings Errors and warnings can be produced from inside a parse transform, with a bit of care. The easiest way is to simply produce an {error, Err} or {warning, Warn} form in place. This function finds such forms, and removes them from the form list (otherwise, the linter will crash), and produces a return value that the compiler can work with. The format of the error and warning &quot;forms&quot; must be {Tag, {Pos, Module, Info}} , where: Tag :: error | warning Pos :: LineNumber | {LineNumber, ColumnNumber} Module is a module that exports a corresponding Module:format_error(Info) Info :: term() If the error is in the form of a caught exception, Info may be produced using the function format_exception/2 .","ref":"parse_trans.html#return/2","title":"parse_trans.return/2","type":"function"},{"doc":"Reverts back from Syntax Tools format to Erlang forms. Note that the Erlang forms are a subset of the Syntax Tools syntax tree, so this function is safe to call even on a list of regular Erlang forms. Note2: R16B03 introduced a bug, where forms produced by erl_syntax:revert/1 (specifically, implicit funs) could crash the linter. This function works around that limitation, after first verifying that it's necessary to do so. Use of the workaround can be forced with the help of the parse_trans environment variable {revert_workaround, true}. This variable will be removed when R16B03 is no longer 'supported'.","ref":"parse_trans.html#revert/1","title":"parse_trans.revert/1","type":"function"},{"doc":"Reverts a single form back from Syntax Tools format to Erlang forms. erl_syntax:revert/1 has had a long-standing bug where it doesn't completely revert attribute forms. This function deals properly with those cases. Note that the Erlang forms are a subset of the Syntax Tools syntax tree, so this function is safe to call even on a regular Erlang form. Note2: R16B03 introduced a bug, where forms produced by erl_syntax:revert/1 (specifically, implicit funs) could crash the linter. This function works around that limitation, after first verifying that it's necessary to do so. Use of the workaround can be forced with the help of the parse_trans environment variable {revert_workaround, true}. This variable will be removed when R16B03 is no longer 'supported'.","ref":"parse_trans.html#revert_form/1","title":"parse_trans.revert_form/1","type":"function"},{"doc":null,"ref":"parse_trans.html#top/3","title":"parse_trans.top/3","type":"function"},{"doc":"Makes one pass","ref":"parse_trans.html#transform/4","title":"parse_trans.transform/4","type":"function"},{"doc":null,"ref":"parse_trans.html#t:form/0","title":"parse_trans.form/0","type":"type"},{"doc":null,"ref":"parse_trans.html#t:forms/0","title":"parse_trans.forms/0","type":"type"},{"doc":null,"ref":"parse_trans.html#t:insp_f/0","title":"parse_trans.insp_f/0","type":"type"},{"doc":null,"ref":"parse_trans.html#t:options/0","title":"parse_trans.options/0","type":"type"},{"doc":null,"ref":"parse_trans.html#t:type/0","title":"parse_trans.type/0","type":"type"},{"doc":null,"ref":"parse_trans.html#t:xform_f_df/0","title":"parse_trans.xform_f_df/0","type":"type"},{"doc":null,"ref":"parse_trans.html#t:xform_f_rec/0","title":"parse_trans.xform_f_rec/0","type":"type"},{"doc":"Parse transform for code generation pseduo functions ...","ref":"parse_trans_codegen.html","title":"parse_trans_codegen","type":"module"},{"doc":null,"ref":"parse_trans_codegen.html#format_error/1","title":"parse_trans_codegen.format_error/1","type":"function"},{"doc":"Searches for calls to pseudo functions in the module codegen , and converts the corresponding erlang code to a data structure representing the abstract form of that code. The purpose of these functions is to let the programmer write the actual code that is to be generated, rather than manually writing abstract forms, which is more error prone and cannot be checked by the compiler until the generated module is compiled. Supported functions: gen_function/2 Usage: codegen:gen_function(Name, Fun) Substitutes the abstract code for a function with name Name and the same behaviour as Fun . Fun can either be a anonymous fun , which is then converted to a named function, or it can be an implicit fun , e.g. fun is_member/2 . In the latter case, the referenced function is fetched and converted to an abstract form representation. It is also renamed so that the generated function has the name Name . Another alternative is to wrap a fun inside a list comprehension, e.g. f ( Name , L ) -&gt; codegen : gen_function ( Name , [ fun ( { &#39;$var&#39; , X } ) -&gt; { &#39;$var&#39; , Y } end || { X , Y } &amp; lt ; - L ] ) . Calling the above with f(foo, [{1,a},{2,b},{3,c}]) will result in generated code corresponding to: foo ( 1 ) -&gt; a ; foo ( 2 ) -&gt; b ; foo ( 3 ) -&gt; c . gen_functions/1 Takes a list of {Name, Fun} tuples and produces a list of abstract data objects, just as if one had written [codegen:gen_function(N1,F1),codegen:gen_function(N2,F2),...] . exprs/1 Usage: codegen:exprs(Fun) Fun is either an anonymous function, or an implicit fun with only one function clause. This &quot;function&quot; takes the body of the fun and produces a data type representing the abstract form of the list of expressions in the body. The arguments of the function clause are ignored, but can be used to ensure that all necessary variables are known to the compiler. gen_module/3 Generates abstract forms for a complete module definition. Usage: codegen:gen_module(ModuleName, Exports, Functions) ModuleName is either an atom or a {'$var', V} reference. Exports is a list of {Function, Arity} tuples. Functions is a list of {Name, Fun} tuples analogous to that for gen_functions/1 . Variable substitution It is possible to do some limited expansion (importing a value bound at compile-time), using the construct {'$var', V} , where V is a bound variable in the scope of the call to gen_function/2 . Example: gen ( Name , X ) -&gt; codegen : gen_function ( Name , fun ( L ) -&gt; lists : member ( { &#39;$var&#39; , X } , L ) end ) . After transformation, calling gen(contains_17, 17) will yield the abstract form corresponding to: contains_17 ( L ) -&gt; lists : member ( 17 , L ) . Form substitution It is possible to inject abstract forms, using the construct {'$form', F} , where F is bound to a parsed form in the scope of the call to gen_function/2 . Example: gen ( Name , F ) -&gt; codegen : gen_function ( Name , fun ( X ) -&gt; X =:= { &#39;$form&#39; , F } end ) . After transformation, calling gen(is_foo, {atom,0,foo}) will yield the abstract form corresponding to: is_foo ( X ) -&gt; X =:= foo .","ref":"parse_trans_codegen.html#parse_transform/2","title":"parse_trans_codegen.parse_transform/2","type":"function"},{"doc":null,"ref":"parse_trans_mod.html","title":"parse_trans_mod","type":"module"},{"doc":null,"ref":"parse_trans_mod.html#abstract_code/1","title":"parse_trans_mod.abstract_code/1","type":"function"},{"doc":null,"ref":"parse_trans_mod.html#beam_file/1","title":"parse_trans_mod.beam_file/1","type":"function"},{"doc":null,"ref":"parse_trans_mod.html#compile_and_load_forms/1","title":"parse_trans_mod.compile_and_load_forms/1","type":"function"},{"doc":null,"ref":"parse_trans_mod.html#compile_and_load_forms/2","title":"parse_trans_mod.compile_and_load_forms/2","type":"function"},{"doc":null,"ref":"parse_trans_mod.html#compile_options/1","title":"parse_trans_mod.compile_options/1","type":"function"},{"doc":null,"ref":"parse_trans_mod.html#rename_module/2","title":"parse_trans_mod.rename_module/2","type":"function"},{"doc":null,"ref":"parse_trans_mod.html#transform_module/3","title":"parse_trans_mod.transform_module/3","type":"function"},{"doc":null,"ref":"parse_trans_mod.html#t:compile_options/0","title":"parse_trans_mod.compile_options/0","type":"type"},{"doc":null,"ref":"parse_trans_mod.html#t:erlang_form/0","title":"parse_trans_mod.erlang_form/0","type":"type"},{"doc":"Generic parse transform library for Erlang. This module contains some useful utility functions for inspecting the results of parse transforms or code generation. The function main/1 is called from escript, and can be used to pretty-print debug info in a .beam file from a Linux shell. Using e.g. the following bash alias: alias pp = &#39;escript $PARSE_TRANS_ROOT/ebin/parse_trans_pp.beam&#39; a file could be pretty-printed using the following command: $ pp ex_codegen.beam | less","ref":"parse_trans_pp.html","title":"parse_trans_pp","type":"module"},{"doc":null,"ref":"parse_trans_pp.html#main/1","title":"parse_trans_pp.main/1","type":"function"},{"doc":"Reads debug_info from the beam file Beam and returns a string containing the pretty-printed corresponding erlang source code.","ref":"parse_trans_pp.html#pp_beam/1","title":"parse_trans_pp.pp_beam/1","type":"function"},{"doc":"Reads debug_info from the beam file Beam and pretty-prints it as Erlang source code, storing it in the file Out.","ref":"parse_trans_pp.html#pp_beam/2","title":"parse_trans_pp.pp_beam/2","type":"function"},{"doc":"Pretty-prints the erlang source code corresponding to Forms into Out","ref":"parse_trans_pp.html#pp_src/2","title":"parse_trans_pp.pp_src/2","type":"function"},{"doc":"# The parse_trans application #\n\n__Authors:__ Ulf Wiger ([`ulf@wiger.net`](mailto:ulf@wiger.net)).\n\nParse_transform utilities\n\n[![Build Status](https://github.com/uwiger/parse_trans/actions/workflows/ci.yml/badge.svg?branch=master)](https://github.com/uwiger/parse_trans/actions/workflows/ci.yml)\n[![Hex pm](http://img.shields.io/hexpm/v/parse_trans.svg?style=flat)](https://hex.pm/packages/parse_trans)","ref":"readme.html","title":"The parse_trans application","type":"extras"},{"doc":"Parse_trans was written in order to capture some useful patterns in parse transformation\nand code generation for Erlang.\n\nMost notably, perhaps, the module [`exprecs`](http://github.com/uwiger/parse_trans/blob/master/doc/exprecs.md) generates standardized accessor\nfunctions for records, and [`ct_expand`](http://github.com/uwiger/parse_trans/blob/master/doc/ct_expand.md) makes it possible to evaluate an\nexpression at compile-time and substitute the result as a compile-time constant.\n\nLess known modules, perhaps:\n* [`parse_trans_pp`](http://github.com/uwiger/parse_trans/blob/master/doc/parse_trans_pp.md) can be called with escript to pretty-print source from\n  debug-compiled .beam files.\n* [`parse_trans_codegen`](http://github.com/uwiger/parse_trans/blob/master/doc/parse_trans_codegen.md) provides pseudo-functions that can be used for\n  simple code generation.\n* [`parse_trans`](http://github.com/uwiger/parse_trans/blob/master/doc/parse_trans.md) provides various helper functions for traversing code and\n  managing complex parse transforms","ref":"readme.html#introduction","title":"Introduction ## - The parse_trans application","type":"extras"},{"doc":"ct_expand   \n   exprecs   \n   parse_trans   \n   parse_trans_codegen   \n   parse_trans_mod   \n   parse_trans_pp","ref":"readme.html#modules","title":"Modules ## - The parse_trans application","type":"extras"},{"doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html","title":"LICENSE","type":"extras"}]}